
// polymorphic_medleyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "polymorphic_medleyApp.h"
#include "polymorphic_medleyDlg.h"
#include "afxdialogex.h"

#include "standard_crypto_primitives.h"
#include "polymorphic_medley.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// Cpolymorphic_medleyDlg dialog




Cpolymorphic_medleyDlg::Cpolymorphic_medleyDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(Cpolymorphic_medleyDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cpolymorphic_medleyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATUS_STATIC, m_StatusStatic);
	DDX_Control(pDX, IDC_EDIT1, m_filename_edit);
	DDX_Control(pDX, IDC_EDIT2, m_key_edit);
}

BEGIN_MESSAGE_MAP(Cpolymorphic_medleyDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ENCRYPT_0X00_BTN, &Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn)
	ON_BN_CLICKED(IDC_ENCRYPT_0X00_BTN2, &Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn2)
	ON_BN_CLICKED(IDC_ENCRYPT_0X00_BTN3, &Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn3)
	ON_BN_CLICKED(IDC_AES_SPEED_TEST_BTN, &Cpolymorphic_medleyDlg::OnBnClickedAesSpeedTestBtn)
	ON_BN_CLICKED(IDC_PMCMED_SPEED_TEST_BTN, &Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn)
	ON_BN_CLICKED(IDC_PMCMED_SPEED_TEST_BTN2, &Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn2)
	ON_BN_CLICKED(IDC_PMCMED_SPEED_TEST_BTN3, &Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn3)
	ON_BN_CLICKED(IDC_PMCMED_SPEED_TEST_KEY_SETUP_BTN, &Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestKeySetupBtn)
	ON_BN_CLICKED(IDC_AES_KEY_SETUP_TIME_TEST_BTN, &Cpolymorphic_medleyDlg::OnBnClickedAesKeySetupTimeTestBtn)
	ON_BN_CLICKED(IDC_ENCRYPT_FILE_BTN, &Cpolymorphic_medleyDlg::OnBnClickedEncryptFileBtn)
	ON_BN_CLICKED(IDC_DECRYPT_FILE_BTN, &Cpolymorphic_medleyDlg::OnBnClickedDecryptFileBtn)
END_MESSAGE_MAP()


// Cpolymorphic_medleyDlg message handlers

BOOL Cpolymorphic_medleyDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

		// test standard algorithms
	if (crypto_primitives::test_SHA_1()!=true) {
		::MessageBox(NULL,L"SHA-1 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::sha256_test()!=true) {
		::MessageBox(NULL,L"SHA-256 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::ripemd128_test()!=true) {
		::MessageBox(NULL,L"RIPEMD-128 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::ripemd160_test()!=true) {
		::MessageBox(NULL,L"RIPEMD-160 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::ripemd256_test()!=true) {
		::MessageBox(NULL,L"RIPEMD-256 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::ripemd320_test()!=true) {
		::MessageBox(NULL,L"RIPEMD-320 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::test_MD5()!=true) {
		::MessageBox(NULL,L"MD5 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::tiger_128_test()!=true) {
		::MessageBox(NULL,L"Tiger 128 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::tiger_160_test()!=true) {
		::MessageBox(NULL,L"Tiger 160 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::tiger_192_test()!=true) {
		::MessageBox(NULL,L"Tiger 256 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::haval160_test()!=true) {
		::MessageBox(NULL,L"HAVAL 160 test failed",L"Error",MB_OK);
		return FALSE;
	}
	if (crypto_primitives::haval256_test()!=true) {
		::MessageBox(NULL,L"HAVAL 256 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::whirlpool_test()!=true) {
		::MessageBox(NULL,L"Whirlpool (512bit) test failed",L"Error",MB_OK);
		return FALSE;
	}


		// test available 128 bit block ciphers (some ciphers are tested for longer key lengths than 128 bits as well, but 128 bit block and key length are ALWAYS tested)

	if (crypto_primitives::twofish_self_test()!=true) {
		::MessageBox(NULL,L"Twofish test failed",L"Error",MB_OK);
		return FALSE;
	}

		// tests 128, 192 and 256 bit key length
	if (crypto_primitives::test_AES()!=true) {
		::MessageBox(NULL,L"AES Rijndael test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::serpent_self_test()!=true) {
		::MessageBox(NULL,L"Serpent test failed",L"Error",MB_OK);
		return FALSE;
	}
	
	if (crypto_primitives::cast256_self_test()!=true) {
		::MessageBox(NULL,L"Serpent test failed",L"Error",MB_OK);
		return FALSE;
	}
	
	if (crypto_primitives::test_camellia()!=true) {
		::MessageBox(NULL,L"Camellia test failed",L"Error",MB_OK);
		return FALSE;
	}
	
	if (crypto_primitives::test_RC6()!=true) {
		::MessageBox(NULL,L"RC6 test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (crypto_primitives::test_SEED()!=true) {
		::MessageBox(NULL,L"SEED test failed",L"Error",MB_OK);
		return FALSE;
	}
	
	if (crypto_primitives::test_Anubis()!=true) {
		::MessageBox(NULL,L"Anubis test failed",L"Error",MB_OK);
		return FALSE;
	}

	if (polymorphic_medley_cipher::test_PMC_Medley()!=true) {
		::MessageBox(NULL,L"Polymorphic Medley test failed",L"Error",MB_OK);
		return FALSE;
	}

	m_StatusStatic.SetWindowText(L"Ready with testing all base ciphers and compression functions.");

	m_filename_edit.SetWindowTextW(L"c:\\pmcmed\\test_file.mpg");
	m_key_edit.SetLimitText(MAX_PATH-8);
	m_key_edit.SetWindowTextW(L"123");
	m_key_edit.SetLimitText(128);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void Cpolymorphic_medleyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cpolymorphic_medleyDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cpolymorphic_medleyDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}






	// AES speed test: Encryption of 256Mbyte with only one time key setup
void Cpolymorphic_medleyDlg::OnBnClickedAesSpeedTestBtn()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD dwStartTime,dwEndTime;
	__int64 i64start_time,i64end_time;
	WCHAR s[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Encrypting 256 Mbyte using AES Rijndael. Please wait ...");

	dwStartTime=GetTickCount();

	AES_Speed_Test();

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;

	i64end_time=i64end_time-i64start_time;

		// 8*256MByte = 2048MBit
	swprintf(s,256,L"Time to encrypt 256 Mbyte using AES Rijndael: %I64d milliseconds => %e Mbit/s",i64end_time,2048.0*1000.0/i64end_time);
	m_StatusStatic.SetWindowText(s);
}


	// AES speed test: How long do 10.000.000 key setups take?
void Cpolymorphic_medleyDlg::OnBnClickedAesKeySetupTimeTestBtn()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD dwStartTime,dwEndTime;
	__int64 i64start_time,i64end_time;
	WCHAR s[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Setting up 10.000.000 AES Rijndael keys. Please wait ...");

	dwStartTime=GetTickCount();

	AES_10million_key_setups_speed_Test();

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;

	i64end_time=i64end_time-i64start_time;

	swprintf(s,256,L"Time to set up 10.000.000 AES Rijndael keys: %I64d milliseconds => %e keys/s",i64end_time,10000000.0/(i64end_time*0.001));
	m_StatusStatic.SetWindowText(s);
}









void Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn()
{
	using namespace					polymorphic_medley_cipher;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	int										* pI;
	uint32									key_length_in_bits=1024;
	uint32									complexity=65535;
	PMCMED_cipher_context		PMCMED_cc;

	word64									no_of_bytes_written=0LL;
	uint8										data[16];
	uint8										ciphertext[16];
	uint8									*	out_buf = new uint8[1048576+2048]; // 1MB + a little more
	uint8									*	pOut_buf;
	CString									filename;
	HANDLE									hFileWrite;
	DWORD										dwBytesWritten;
	WCHAR										s[256];

	pI=(int *)&data[0];																																										// we'll copy  into the plaintext array in order to encrypt something different all the time. ECB mode requires us to do such stuff.

	filename="c:\\rng_tests\\pm.bin";

	for (i=0;i<128;i++) key[i]=0x00;
	if (PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity)) goto OnBnClickedEncrypt0x00Btn_end;// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state

	hFileWrite=CreateFile(filename,GENERIC_READ | GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if (hFileWrite!=INVALID_HANDLE_VALUE)
	{

		m_StatusStatic.SetWindowText(L"Encrypting 64Mbyte using PMCMED_encrypt_cascade() ..");

		pOut_buf=out_buf;
		for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
		{
			memset(data,0,16);	// we clear used parts of the buffer
			*pI=i;																																													// add our block counter

			PMCMED_encrypt_cascade((void *)&PMCMED_cc,data,ciphertext);																			// encryption in ECB mode: all 8 cipher primitives are used to encrypt a single block of data

			memcpy(pOut_buf,ciphertext,16);
			pOut_buf=pOut_buf+16;

			if (pOut_buf>=out_buf+1048576)
			{
				WriteFile(hFileWrite,out_buf,1048576,&dwBytesWritten,NULL);
				pOut_buf=out_buf;
				no_of_bytes_written+=1048576LL;

				swprintf(s,256,L"GBPMC Test: %I64d bytes written",no_of_bytes_written);
				m_StatusStatic.SetWindowText(s);
				m_StatusStatic.RedrawWindow(0,0,RDW_UPDATENOW);

			} // if (pOut_buf>=out_buf+1048576)
		} // for (i=0;i<4194304;i++)
		CloseHandle(hFileWrite);
		m_StatusStatic.SetWindowText(L"Ready with encrypting 64Mbyte using PMCMED_encrypt_cascade().");

		PMCMED_free_memory((void*)&PMCMED_cc);
		delete [] out_buf;
	} // if (hFileWrite!=INVALID_HANDLE_VALUE)

OnBnClickedEncrypt0x00Btn_end:
	i=0;																																																	// dummy operation
}


void Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn2()
{
	using namespace					polymorphic_medley_cipher;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	int										* pI;
	uint32									key_length_in_bits=1024;
	uint32									complexity=65535;
	PMCMED_cipher_context		PMCMED_cc;

	word64									no_of_bytes_written=0LL;
	uint8										data[16];
	uint8										ciphertext[16];
	uint8									*	out_buf = new uint8[1048576+2048]; // 1MB + a little more
	uint8									*	pOut_buf;
	CString									filename;
	HANDLE									hFileWrite;
	DWORD										dwBytesWritten;
	WCHAR										s[256];

	pI=(int *)&data[0];																																										// we'll copy  into the plaintext array in order to encrypt something different all the time. ECB mode requires us to do such stuff.

	filename="c:\\rng_tests\\pm.bin";

	for (i=0;i<128;i++) key[i]=0x00;
	if (PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity)) goto OnBnClickedEncrypt0x00Btn2_end;// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state

	hFileWrite=CreateFile(filename,GENERIC_READ | GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if (hFileWrite!=INVALID_HANDLE_VALUE)
	{

		m_StatusStatic.SetWindowText(L"Encrypting 64Mbyte using PMCMED_encrypt_max_var_cascade() ..");

		pOut_buf=out_buf;
		for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
		{
			memset(data,0,16);	// we clear used parts of the buffer
			*pI=i;																																													// add our block counter

			PMCMED_encrypt_max_var_cascade((void *)&PMCMED_cc,data,ciphertext);															// encryption in ECB mode: free choice of the base ciphers => 2^24 possible combinations

			memcpy(pOut_buf,ciphertext,16);
			pOut_buf=pOut_buf+16;

			if (pOut_buf>=out_buf+1048576)
			{
				WriteFile(hFileWrite,out_buf,1048576,&dwBytesWritten,NULL);
				pOut_buf=out_buf;
				no_of_bytes_written+=1048576LL;

				swprintf(s,256,L"GBPMC Test: %I64d bytes written",no_of_bytes_written);
				m_StatusStatic.SetWindowText(s);
				m_StatusStatic.RedrawWindow(0,0,RDW_UPDATENOW);

			} // if (pOut_buf>=out_buf+1048576)
		} // for (i=0;i<4194304;i++)
		CloseHandle(hFileWrite);
		m_StatusStatic.SetWindowText(L"Ready with encrypting 64Mbyte using PMCMED_encrypt_max_var_cascade().");

		PMCMED_free_memory((void*)&PMCMED_cc);
		delete [] out_buf;
	} // if (hFileWrite!=INVALID_HANDLE_VALUE)

OnBnClickedEncrypt0x00Btn2_end:
	i=0;																																																	// dummy operation
}


void Cpolymorphic_medleyDlg::OnBnClickedEncrypt0x00Btn3()
{
	using namespace					polymorphic_medley_cipher;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	int										* pI;
	uint32									key_length_in_bits=1024;
	uint32									complexity=65535;
	PMCMED_cipher_context		PMCMED_cc;

	word64									no_of_bytes_written=0LL;
	uint8										data[16];
	uint8										ciphertext[16];
	uint8									*	out_buf = new uint8[1048576+2048]; // 1MB + a little more
	uint8									*	pOut_buf;
	CString									filename;
	HANDLE									hFileWrite;
	DWORD										dwBytesWritten;
	WCHAR										s[256];

	pI=(int *)&data[0];																																										// we'll copy  into the plaintext array in order to encrypt something different all the time. ECB mode requires us to do such stuff.

	filename="c:\\rng_tests\\pm.bin";

	for (i=0;i<128;i++) key[i]=0x00;
	if (PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity)) goto OnBnClickedEncrypt0x00Btn3_end;// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state

	PMCMED_init_CBC_mode((void *)&PMCMED_cc,0);	

	hFileWrite=CreateFile(filename,GENERIC_READ | GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if (hFileWrite!=INVALID_HANDLE_VALUE)
	{

		m_StatusStatic.SetWindowText(L"Encrypting 64Mbyte using PMCMED_CBC_encrypt_cascade() ..");

		pOut_buf=out_buf;
		for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
		{
			memset(data,0,16);																																							// we clear used parts of the buffer
				// no need to add block counter as CBC automatically adds lots of pseudorandomness
			PMCMED_CBC_encrypt_cascade((void *)&PMCMED_cc,data,ciphertext);																	// encryption in CBC mode: free AND CHANGING choice of the base ciphers => 2^24 possible combinations

			memcpy(pOut_buf,ciphertext,16);
			pOut_buf=pOut_buf+16;

			if (pOut_buf>=out_buf+1048576)
			{
				WriteFile(hFileWrite,out_buf,1048576,&dwBytesWritten,NULL);
				pOut_buf=out_buf;
				no_of_bytes_written+=1048576LL;

				swprintf(s,256,L"GBPMC Test: %I64d bytes written",no_of_bytes_written);
				m_StatusStatic.SetWindowText(s);
				m_StatusStatic.RedrawWindow(0,0,RDW_UPDATENOW);

			} // if (pOut_buf>=out_buf+1048576)
		} // for (i=0;i<4194304;i++)
		CloseHandle(hFileWrite);
		m_StatusStatic.SetWindowText(L"Ready with encrypting 64Mbyte using PMCMED_CBC_encrypt_cascade().");

		PMCMED_free_memory((void*)&PMCMED_cc);
		delete [] out_buf;
	} // if (hFileWrite!=INVALID_HANDLE_VALUE)

OnBnClickedEncrypt0x00Btn3_end:
	i=0;																																																	// dummy operation
}




void Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD										dwStartTime,dwEndTime;
	__int64									i64start_time,i64end_time;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	int										* pI;
	uint32									key_length_in_bits=128;
	uint32									complexity=0;
	PMCMED_cipher_context		PMCMED_cc;

	uint8										data[16];
	uint8										ciphertext[16];
	WCHAR										s[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Encrypting 64 Mbyte using Polymorphic Medley PMCMED_encrypt_cascade(). Please wait ...");

	dwStartTime=GetTickCount();
	
	pI=(int *)&data[0];																																										// we'll copy  into the plaintext array in order to encrypt something different all the time. ECB mode requires us to do such stuff.

	for (i=0;i<128;i++) key[i]=0x00;
	PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity);													// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state

		// encryption of 64 Mbyte of data
	for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
	{
		memset(data,0,16);																																									// we clear used parts of the buffer
		*pI=i;																																															// add our block counter
				// no need to add block counter as CBC automatically adds lots of pseudorandomness
		PMCMED_encrypt_cascade((void *)&PMCMED_cc,data,ciphertext);																					// encryption in ECB mode: all 8 cipher primitives are used to encrypt a single block of data
	}

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;
	i64end_time=i64end_time-i64start_time;

		// 8*256MByte = 2048MBit
	swprintf(s,256,L"Time to encrypt 64 Mbyte using Polymorphic Medley PMCMED_encrypt_cascade(): %I64d milliseconds => %e Mbit/s",i64end_time,2048.0*1000.0/i64end_time);
	m_StatusStatic.SetWindowText(s);

	PMCMED_free_memory((void*)&PMCMED_cc);
}


void Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn2()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD										dwStartTime,dwEndTime;
	__int64									i64start_time,i64end_time;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	int										* pI;
	uint32									key_length_in_bits=128;
	uint32									complexity=0;
	PMCMED_cipher_context		PMCMED_cc;

	uint8										data[16];
	uint8										ciphertext[16];
	WCHAR										s[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Encrypting 64 Mbyte using Polymorphic Medley PMCMED_encrypt_max_var_cascade(). Please wait ...");

	dwStartTime=GetTickCount();
	
	pI=(int *)&data[0];																																										// we'll copy  into the plaintext array in order to encrypt something different all the time. ECB mode requires us to do such stuff.

	for (i=0;i<128;i++) key[i]=0x00;
	PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity);													// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state

		// encryption of 64 Mbyte of data
	for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
	{
		memset(data,0,16);																																									// we clear used parts of the buffer
		*pI=i;																																															// add our block counter
				// no need to add block counter as CBC automatically adds lots of pseudorandomness
		PMCMED_encrypt_max_var_cascade((void *)&PMCMED_cc,data,ciphertext);																	// encryption in ECB mode: free choice of the base ciphers => 2^24 possible combinations
	}

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;
	i64end_time=i64end_time-i64start_time;

		// 8*256MByte = 2048MBit
	swprintf(s,256,L"Time to encrypt 64 Mbyte using Polymorphic Medley PMCMED_encrypt_max_var_cascade(): %I64d milliseconds => %e Mbit/s",i64end_time,2048.0*1000.0/i64end_time);
	m_StatusStatic.SetWindowText(s);

	PMCMED_free_memory((void*)&PMCMED_cc);
}


void Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestBtn3()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD										dwStartTime,dwEndTime;
	__int64									i64start_time,i64end_time;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	uint32									key_length_in_bits=128;
	uint32									complexity=0;
	PMCMED_cipher_context		PMCMED_cc;

	uint8										data[16];
	uint8										ciphertext[16];
	WCHAR										s[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Encrypting 64 Mbyte using Polymorphic Medley PMCMED_CBC_encrypt_cascade(). Please wait ...");

	dwStartTime=GetTickCount();

	for (i=0;i<128;i++) key[i]=0x00;
	PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity);													// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state
	PMCMED_init_CBC_mode((void *)&PMCMED_cc,0);																														// 0: CBC_block_counter_start_value must be the same for decryption. It is good e.g. for encrypting data streams and it is automatically incremented by PMCMED_CBC_encrypt_cascade()

		// encryption of 64 Mbyte of data
	for (i=0;i<4194304;i++) // 16 * 2^22 = 2^26 
	{
		memset(data,0,16);																																									// we clear used parts of the buffer
				// no need to add block counter as CBC automatically adds lots of pseudorandomness
		PMCMED_CBC_encrypt_cascade((void *)&PMCMED_cc,data,ciphertext);																			// encryption in CBC mode: all 8 cipher primitives are used to encrypt a single block of data
	}

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;
	i64end_time=i64end_time-i64start_time;

		// 8*256MByte = 2048MBit
	swprintf(s,256,L"Time to encrypt 64 Mbyte using Polymorphic Medley PMCMED_CBC_encrypt_cascade(): %I64d milliseconds => %e Mbit/s",i64end_time,2048.0*1000.0/i64end_time);
	m_StatusStatic.SetWindowText(s);

	PMCMED_free_memory((void*)&PMCMED_cc);
}


void Cpolymorphic_medleyDlg::OnBnClickedPmcmedSpeedTestKeySetupBtn()
{
	using namespace					polymorphic_medley_cipher;																										// our test routine for AES is in there so that we don't nmeed to include standard_crypto_primitives.h in this source code file
	DWORD										dwStartTime,dwEndTime;
	__int64									i64start_time,i64end_time;
	char										key[128];																																			// max. 1024 bit keysize
	int											i;
	uint32									key_length_in_bits=128;
	uint32									complexity=0;
	PMCMED_cipher_context		PMCMED_cc;
	WCHAR										s[256],s2[256];

		// init cipher
	m_StatusStatic.SetWindowText(L"Polymorphic Medley: 100/100 key setups, complexity 256 and 65535. Please wait ...");


	for (i=0;i<128;i++) key[i]=0x00;

	dwStartTime=GetTickCount();
		// 100 key setups
	complexity=256;
	for (i=0;i<100;i++)
	{
		PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity);													// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state
		PMCMED_free_memory((void*)&PMCMED_cc);
	}

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;
	i64end_time=i64end_time-i64start_time;

	swprintf(s,256,L"Polymorphic Medley: 100 key setups with complexity 256: %e key setups/s,\n100 key setups with complexity 65535: ",100.0*1000.0/i64end_time);
	m_StatusStatic.SetWindowText(s);


	dwStartTime=GetTickCount();
		// 100 key setups
	complexity=65535;
	for (i=0;i<100;i++)
	{
		PMCMED_keysetup((uint8*)key,(void*)&PMCMED_cc,key_length_in_bits,complexity);													// key_length_in_bits: 128 .. 1024 bit, complexity: 0: very fast, 2^16-1: huge set of keyed operations to compute internal state
		PMCMED_free_memory((void*)&PMCMED_cc);
	}

	dwEndTime=GetTickCount();
	if (dwEndTime<dwStartTime) i64end_time=dwEndTime+4294967296;
	else i64end_time=dwEndTime;
	i64start_time=dwStartTime;
	i64end_time=i64end_time-i64start_time;


	swprintf(s2,256,L"%e key setups/s",100.0*1000.0/i64end_time);
	wcscat_s(s,256,s2);
	m_StatusStatic.SetWindowText(s);
}




void Cpolymorphic_medleyDlg::OnBnClickedEncryptFileBtn()
{
	using namespace					polymorphic_medley_cipher;

	int i;
	size_t	num_of_converted_characters;
	WCHAR wc_filepath[MAX_PATH];
	WCHAR wc_ciphertext_filepath[MAX_PATH];
	WCHAR wc_key[130];
	char ch_pwd[130];

	m_filename_edit.GetWindowTextW(wc_filepath,MAX_PATH);
	m_key_edit.GetWindowTextW(wc_key,128);

	wcscpy_s(wc_ciphertext_filepath,MAX_PATH,wc_filepath);
	wcscat_s(wc_ciphertext_filepath,MAX_PATH,L"_ENC");


	#ifdef UNICODE 
		wcstombs_s(&num_of_converted_characters,ch_pwd,128,wc_key,128); 
		for (i=(int)num_of_converted_characters;i<128;i++) ch_pwd[i]=0;
	#else
		strcpy_s(ch_pwd,128,cstr.GetBuffer());
	#endif

	m_StatusStatic.SetWindowText(L"Reading and encrypting file ..");
		// return values:
		// 0: no errors
		// 1: Could not open plaintext file.
		// 2: Could not create ciphertext file.
	i=EncryptFileWithPolymorphicMedley(wc_filepath,wc_ciphertext_filepath,(uint8*)&ch_pwd[0],(int)num_of_converted_characters*8,MAXIMUM_COMPLEXITY_KEY_SETUP);

	m_StatusStatic.SetWindowText(L"Ready with encrypting a file using the Polymorphic Medley cipher.");	// 0: no error
	if (i==1) m_StatusStatic.SetWindowText(L"Could not open plaintext file.");
	if (i==2) m_StatusStatic.SetWindowText(L"Could not create ciphertext file.");
}


void Cpolymorphic_medleyDlg::OnBnClickedDecryptFileBtn()
{
	using namespace					polymorphic_medley_cipher;

	int i;
	size_t	num_of_converted_characters;
	WCHAR wc_filepath[MAX_PATH];
	WCHAR wc_ciphertext_filepath[MAX_PATH];
	WCHAR wc_key[130];
	char ch_pwd[130];

	m_filename_edit.GetWindowTextW(wc_ciphertext_filepath,MAX_PATH);
	m_key_edit.GetWindowTextW(wc_key,128);

	wcscpy_s(wc_filepath,MAX_PATH,wc_ciphertext_filepath);
	wcscat_s(wc_filepath,MAX_PATH,L"_DEC");


	#ifdef UNICODE 
		wcstombs_s(&num_of_converted_characters,ch_pwd,128,wc_key,128); 
		for (i=(int)num_of_converted_characters;i<128;i++) ch_pwd[i]=0;
	#else
		strcpy_s(ch_pwd,128,cstr.GetBuffer());
	#endif

	m_StatusStatic.SetWindowText(L"Reading and decrypting file ..");
		// return values:
		// 0: no errors
		// 1: Could not open plaintext file.
		// 2: Could not create ciphertext file.
	i=DecryptFileWithPolymorphicMedley(wc_ciphertext_filepath,wc_filepath,(uint8*)&ch_pwd[0],(int)num_of_converted_characters*8,MAXIMUM_COMPLEXITY_KEY_SETUP);

	m_StatusStatic.SetWindowText(L"Ready with decrypting a file using the Polymorphic Medley cipher.");	// 0: no error
	if (i==1) m_StatusStatic.SetWindowText(L"Could not open ciphertext file.");
	if (i==2) m_StatusStatic.SetWindowText(L"Could not create plaintext file.");
}
